diff --git a/bam2depth.c b/bam2depth.c
index 0e7cd1891..f19616b0f 100644
--- a/bam2depth.c
+++ b/bam2depth.c
@@ -99,7 +99,7 @@ static int usage() {
 
 int main_depth(int argc, char *argv[])
 {
-    int i, n, tid, beg, end, pos, *n_plp, baseQ = 0, mapQ = 0, min_len = 0;
+    int i, n, tid, reg_tid, beg, end, pos, *n_plp, baseQ = 0, mapQ = 0, min_len = 0;
     int all = 0, status = EXIT_SUCCESS, nfiles, max_depth = -1;
     const bam_pileup1_t **plp;
     char *reg = 0; // specified region
@@ -149,7 +149,7 @@ int main_depth(int argc, char *argv[])
     else
         n = argc - optind; // the number of BAMs on the command line
     data = calloc(n, sizeof(aux_t*)); // data[i] for the i-th input
-    beg = 0; end = INT_MAX;  // set the default region
+    reg_tid = 0; beg = 0; end = INT_MAX;  // set the default region
     for (i = 0; i < n; ++i) {
         int rf;
         data[i] = calloc(1, sizeof(aux_t));
@@ -199,6 +199,7 @@ int main_depth(int argc, char *argv[])
     if (reg) {
         beg = data[0]->iter->beg; // and to the parsed region coordinates
         end = data[0]->iter->end;
+        reg_tid = data[0]->iter->tid;
     }
 
     // the core multi-pileup loop
@@ -210,12 +211,12 @@ int main_depth(int argc, char *argv[])
     while ((ret=bam_mplp_auto(mplp, &tid, &pos, n_plp, plp)) > 0) { // come to the next covered position
         if (pos < beg || pos >= end) continue; // out of range; skip
         if (tid >= h->n_targets) continue;     // diff number of @SQ lines per file?
-        if (bed && bed_overlap(bed, h->target_name[tid], pos, pos + 1) == 0) continue; // not in BED; skip
         if (all) {
             while (tid > last_tid) {
                 if (last_tid >= 0 && !reg) {
-                    // Deal with remainder or entirety of last tid
+                    // Deal with remainder or entirety of last tid.
                     while (++last_pos < h->target_len[last_tid]) {
+                        // Horribly inefficient, but the bed API is an obfuscated black box.
                         if (bed && bed_overlap(bed, h->target_name[last_tid], last_pos, last_pos + 1) == 0)
                             continue;
                         fputs(h->target_name[last_tid], stdout); printf("\t%d", last_pos+1);
@@ -244,6 +245,7 @@ int main_depth(int argc, char *argv[])
             last_tid = tid;
             last_pos = pos;
         }
+        if (bed && bed_overlap(bed, h->target_name[tid], pos, pos + 1) == 0) continue;
         fputs(h->target_name[tid], stdout); printf("\t%d", pos+1); // a customized printf() would be faster
         for (i = 0; i < n; ++i) { // base level filters have to go here
             int j, m = 0;
@@ -262,7 +264,11 @@ int main_depth(int argc, char *argv[])
 
     if (all) {
         // Handle terminating region
-        while (last_tid < h->n_targets) {
+        if (last_tid < 0 && reg && all > 1) {
+            last_tid = reg_tid;
+            last_pos = beg-1;
+        }
+        while (last_tid >= 0 && last_tid < h->n_targets) {
             while (++last_pos < h->target_len[last_tid]) {
                 if (last_pos >= end) break;
                 if (bed && bed_overlap(bed, h->target_name[last_tid], last_pos, last_pos + 1) == 0)
diff --git a/bam_plcmd.c b/bam_plcmd.c
index f4ecfae13..63b8e95b9 100644
--- a/bam_plcmd.c
+++ b/bam_plcmd.c
@@ -240,7 +240,7 @@ static int mplp_func(void *data, bam1_t *b)
         }
         if (ma->conf->rflag_require && !(ma->conf->rflag_require&b->core.flag)) { skip = 1; continue; }
         if (ma->conf->rflag_filter && ma->conf->rflag_filter&b->core.flag) { skip = 1; continue; }
-        if (ma->conf->bed) { // test overlap
+        if (ma->conf->bed && ma->conf->all == 0) { // test overlap
             skip = !bed_overlap(ma->conf->bed, ma->h->target_name[b->core.tid], b->core.pos, bam_endpos(b));
             if (skip) continue;
         }
@@ -319,7 +319,7 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
     extern void *bcf_call_add_rg(void *rghash, const char *hdtext, const char *list);
     extern void bcf_call_del_rghash(void *rghash);
     mplp_aux_t **data;
-    int i, tid, pos, *n_plp, beg0 = 0, end0 = INT_MAX, ref_len, max_depth, max_indel_depth;
+    int i, tid, pos, *n_plp, beg0 = 0, end0 = INT_MAX, tid0 = 0, ref_len, max_depth, max_indel_depth;
     const bam_pileup1_t **plp;
     mplp_ref_t mp_ref = MPLP_REF_INIT;
     bam_mplp_t iter;
@@ -390,7 +390,7 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
                 fprintf(stderr, "[E::%s] fail to parse region '%s' with %s\n", __func__, conf->reg, fn[i]);
                 exit(EXIT_FAILURE);
             }
-            if (i == 0) beg0 = data[i]->iter->beg, end0 = data[i]->iter->end;
+            if (i == 0) beg0 = data[i]->iter->beg, end0 = data[i]->iter->end, tid0 = data[i]->iter->tid;
             hts_idx_destroy(idx);
         }
         else
@@ -567,11 +567,11 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
     // begin pileup
     while ( (ret=bam_mplp_auto(iter, &tid, &pos, n_plp, plp)) > 0) {
         if (conf->reg && (pos < beg0 || pos >= end0)) continue; // out of the region requested
-        if (conf->bed && tid >= 0 && !bed_overlap(conf->bed, h->target_name[tid], pos, pos+1)) continue;
         mplp_get_ref(data[0], tid, &ref, &ref_len);
         //printf("tid=%d len=%d ref=%p/%s\n", tid, ref_len, ref, ref);
         if (conf->flag & MPLP_BCF) {
             int total_depth, _ref0, ref16;
+            if (conf->bed && tid >= 0 && !bed_overlap(conf->bed, h->target_name[tid], pos, pos+1)) continue;
             for (i = total_depth = 0; i < n; ++i) total_depth += n_plp[i];
             group_smpl(&gplp, sm, &buf, n, fn, n_plp, plp, conf->flag & MPLP_IGNORE_RG);
             _ref0 = (ref && pos < ref_len)? ref[pos] : 'N';
@@ -597,10 +597,10 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
                 }
             }
         } else {
-            if (conf->all > 1 && !conf->reg) {
+            if (conf->all) {
                 // Deal with missing portions of previous tids
                 while (tid > last_tid) {
-                    if (last_tid >= 0) {
+                    if (last_tid >= 0 && !conf->reg) {
                         while (++last_pos < h->target_len[last_tid]) {
                             if (conf->bed && bed_overlap(conf->bed, h->target_name[last_tid], last_pos, last_pos + 1) == 0)
                                 continue;
@@ -609,6 +609,8 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
                     }
                     last_tid++;
                     last_pos = -1;
+                    if (conf->all < 2)
+                        break;
                 }
             }
             if (conf->all) {
@@ -622,6 +624,7 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
                 last_tid = tid;
                 last_pos = pos;
             }
+            if (conf->bed && tid >= 0 && !bed_overlap(conf->bed, h->target_name[tid], pos, pos+1)) continue;
 
             fprintf(pileup_fp, "%s\t%d\t%c", h->target_name[tid], pos + 1, (ref && pos < ref_len)? ref[pos] : 'N');
             for (i = 0; i < n; ++i) {
@@ -701,8 +704,13 @@ static int mpileup(mplp_conf_t *conf, int n, char **fn)
     }
 
     if (conf->all && !(conf->flag & MPLP_BCF)) {
-        // Handle terminating region
-        while (last_tid < h->n_targets) {
+        // Handle terminating region 
+        if (last_tid < 0 && conf->reg && conf->all > 1) {
+            last_tid = tid0;
+            last_pos = beg0-1;
+            mplp_get_ref(data[0], tid0, &ref, &ref_len);
+        }
+       while (last_tid >= 0 && last_tid < h->n_targets) {
             while (++last_pos < h->target_len[last_tid]) {
                 if (last_pos >= end0) break;
                 if (conf->bed && bed_overlap(conf->bed, h->target_name[last_tid], last_pos, last_pos + 1) == 0)
diff --git a/test/mpileup/depth.reg b/test/mpileup/depth.reg
index 6916e66bb..3354401a2 100644
--- a/test/mpileup/depth.reg
+++ b/test/mpileup/depth.reg
@@ -13,8 +13,10 @@
 # Create indexed BAMs
 INIT x $samtools view -b -o xx#depth1.bam xx#depth1.sam
 INIT x $samtools view -b -o xx#depth2.bam xx#depth2.sam
+INIT x $samtools view -b -o xx#depth3.bam xx#depth3.sam
 INIT x $samtools index xx#depth1.bam
 INIT x $samtools index xx#depth2.bam
+INIT x $samtools index xx#depth3.bam
 
 # Test basic 1 and 2 file outputs
 P d1_1.out  $samtools depth xx#depth1.sam
@@ -32,6 +34,7 @@ P d3_12r1a.out $samtools depth -a -r xx:5-16 xx#depth1.bam xx#depth2.bam
 P d3_12r1a.out $samtools depth -a -b xx.bed  xx#depth1.bam xx#depth2.bam
 P d3_12r2a.out $samtools depth -a -r xx:8-13 xx#depth1.bam xx#depth2.bam
 P d3_12r2a.out $samtools depth -a -b xx.bed2 xx#depth1.bam xx#depth2.bam
+P d3_3.out     $samtools depth -a xx#depth3.bam
 
 # With double -a for all including unused refs
 P d4_12.out  $samtools depth -a -a            xx#depth1.bam xx#depth2.bam
diff --git a/test/mpileup/expected/d3_3.out b/test/mpileup/expected/d3_3.out
new file mode 100644
index 000000000..8a127735e
--- /dev/null
+++ b/test/mpileup/expected/d3_3.out
@@ -0,0 +1,40 @@
+xx	1	0
+xx	2	0
+xx	3	0
+xx	4	0
+xx	5	0
+xx	6	1
+xx	7	1
+xx	8	1
+xx	9	0
+xx	10	0
+xx	11	0
+xx	12	0
+xx	13	0
+xx	14	0
+xx	15	0
+xx	16	0
+xx	17	0
+xx	18	0
+xx	19	0
+xx	20	0
+xn	1	0
+xn	2	0
+xn	3	0
+xn	4	0
+xn	5	0
+xn	6	0
+xn	7	0
+xn	8	0
+xn	9	0
+xn	10	0
+xn	11	0
+xn	12	0
+xn	13	1
+xn	14	1
+xn	15	1
+xn	16	0
+xn	17	0
+xn	18	0
+xn	19	0
+xn	20	0
diff --git a/test/mpileup/xx#depth3.sam b/test/mpileup/xx#depth3.sam
new file mode 100644
index 000000000..3c9e7b438
--- /dev/null
+++ b/test/mpileup/xx#depth3.sam
@@ -0,0 +1,7 @@
+@HD	VN:1.4	SO:coordinate
+@SQ	SN:xp	LN:20	AS:?	SP:?	UR:?	M5:bbf4de6d8497a119dda6e074521643dc
+@SQ	SN:xx	LN:20	AS:?	SP:?	UR:?	M5:bbf4de6d8497a119dda6e074521643dc
+@SQ	SN:xy	LN:20	AS:?	SP:?	UR:?	M5:bbf4de6d8497a119dda6e074521643dc
+@SQ	SN:xn	LN:20	AS:?	SP:?	UR:?	M5:bbf4de6d8497a119dda6e074521643dc
+a1	16	xx	6	1	3M	*	0	0	*	*
+b1	16	xn	13	1	3M	*	0	0	*	*
diff --git a/test/mpileup/xx.fa b/test/mpileup/xx.fa
index e8795c066..3ef3c6bac 100644
--- a/test/mpileup/xx.fa
+++ b/test/mpileup/xx.fa
@@ -2,4 +2,5 @@
 AAAAAAAAAATTTTTTTTTTCCCCC
 >yy
 AAAAAAAAAATTTTTTTTTT
-
+>xy
+GGGGGTTTTTAAAAACCCCC
diff --git a/test/mpileup/xx.fa.fai b/test/mpileup/xx.fa.fai
index 0cc84ba5f..fe045fe2e 100644
--- a/test/mpileup/xx.fa.fai
+++ b/test/mpileup/xx.fa.fai
@@ -1,2 +1,3 @@
 xx	25	4	25	26
 yy	20	34	20	21
+xy	20	59	20	21
